/*
 Navicat Premium Data Transfer

 Source Server         : 50-datax_web
 Source Server Type    : MySQL
 Source Server Version : 50727
 Source Host           : 10.1.21.81:21003
 Source Schema         : datax_web

 Target Server Type    : MySQL
 Target Server Version : 50727
 File Encoding         : 65001

 Date: 16/03/2020 12:03:57
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for job_info
-- ----------------------------
DROP TABLE IF EXISTS `job_info`;
CREATE TABLE `job_info`  (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `job_group` int(11) NOT NULL COMMENT '执行器主键ID',
  `job_cron` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT '任务执行CRON',
  `job_desc` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL,
  `add_time` datetime(0) NULL DEFAULT NULL,
  `update_time` datetime(0) NULL DEFAULT NULL,
  `author` varchar(64) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '作者',
  `alarm_email` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '报警邮件',
  `executor_route_strategy` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '执行器路由策略',
  `executor_handler` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '执行器任务handler',
  `executor_param` varchar(512) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '执行器任务参数',
  `executor_block_strategy` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '阻塞处理策略',
  `executor_timeout` int(11) NOT NULL DEFAULT 0 COMMENT '任务执行超时时间，单位秒',
  `executor_fail_retry_count` int(11) NOT NULL DEFAULT 0 COMMENT '失败重试次数',
  `glue_type` varchar(50) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NOT NULL COMMENT 'GLUE类型',
  `glue_source` mediumtext CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL COMMENT 'GLUE源代码',
  `glue_remark` varchar(128) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT 'GLUE备注',
  `glue_updatetime` datetime(0) NULL DEFAULT NULL COMMENT 'GLUE更新时间',
  `child_jobid` varchar(255) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '子任务ID，多个逗号分隔',
  `trigger_status` tinyint(4) NOT NULL DEFAULT 0 COMMENT '调度状态：0-停止，1-运行',
  `trigger_last_time` bigint(13) NOT NULL DEFAULT 0 COMMENT '上次调度时间',
  `trigger_next_time` bigint(13) NOT NULL DEFAULT 0 COMMENT '下次调度时间',
  `job_json` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT 'datax运行脚本',
  `replace_param` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '动态参数',
  `jvm_param` varchar(200) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT 'jvm参数',
  `inc_start_time` datetime(0) NULL DEFAULT NULL COMMENT '增量初始时间',
  `partition_info` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci NULL DEFAULT NULL COMMENT '分区信息',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 32 CHARACTER SET = utf8mb4 COLLATE = utf8mb4_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of job_info
-- ----------------------------
INSERT INTO `job_info` VALUES (1, 1, '0 0 */1 * * ?', 'test', '2020-03-13 09:33:26', '2020-03-14 16:59:38', '南留', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', '', NULL, '2020-03-13 09:33:26', '', 0, 0, 0, '{\n  \"job\": {\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"mysqlreader\",\n          \"parameter\": {\n            \"column\": [\n              \"app_code\",\n              \"app_name\",\n              \"app_type_industry_name\",\n              \"app_type_industry_code\",\n              \"app_type_level2_name\",\n              \"app_type_level2_code\",\n              \"model_type\",\n              \"create_time\"\n            ],\n            \"connection\": [\n              {\n                \"jdbcUrl\": [\n                  \"jdbc:mysql://10.10.10.50:3306/test?autoReconnect=true&useSSL=false&characterEncoding=UTF-8\"\n                ],\n                \"table\": [\n                  \"hive_mysql\"\n                ]\n              }\n            ],\n            \"password\": \"1qaz!QAZ\",\n            \"username\": \"ds\"\n          }\n        },\n        \"writer\": {\n          \"name\": \"mysqlwriter\",\n          \"parameter\": {\n            \"writeMode\": \"insert\",\n            \"username\": \"ds\",\n            \"password\": \"1qaz!QAZ\",\n            \"column\": [\n              \"app_code\",\n              \"app_name\",\n              \"app_type_industry_name\",\n              \"app_type_industry_code\",\n              \"app_type_level2_name\",\n              \"app_type_level2_code\",\n              \"model_type\",\n              \"create_time\"\n            ],\n            \"connection\": [\n              {\n                \"jdbcUrl\": \"jdbc:mysql://10.10.10.50:3306/test?autoReconnect=true&useSSL=false&characterEncoding=UTF-8\",\n                \"table\": [\n                  \"mysql_mysql\"\n                ]\n              }\n            ]\n          }\n        }\n      }\n    ],\n    \"setting\": {\n      \"speed\": {\n        \"channel\": \"2\"\n      }\n    }\n  }\n}', '', '', NULL, '');
INSERT INTO `job_info` VALUES (3, 1, '0 0 */1 * * ?', 'file_hive', '2020-01-10 23:17:34', '2020-03-12 20:22:43', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-01-10 23:17:34', '', 0, 0, 0, '{\n  \"job\": {\n    \"content\": [\n      {\n        \"reader\": {\n                    \"name\": \"txtfilereader\",\n                    \"parameter\": {\n                        \"path\": [\"/data/ds/third_party/hicore/test_mysql_file__b46d5bab_4fc1_476f_85f0_7975d422c519\"],\n                        \"encoding\": \"UTF-8\",\n                        \"column\": [\n                            {\n                                \"index\": 0,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 1,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 2,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 3,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 4,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 5,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 6,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 7,\n                                \"type\": \"string\"\n                            }\n                        ],\n                        \"fieldDelimiter\": \",\"\n                    }\n        },\n        \"writer\": {\n          \"name\": \"hdfswriter\",\n          \"parameter\": {\n            \"fileType\": \"text\",\n            \"fileName\": \"mysql_hive\",\n            \"path\": \"/user/hive/warehouse/tmp.db/tmp_mysql_hive\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"name\": \"app_code\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_name\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_industry_name\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_industry_code\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_level2_name\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_level2_code\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"model_type\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"create_time\",\n                \"type\": \"VARCHAR\"\n              }\n            ],\n            \"writeMode\": \"append\",\n            \"fieldDelimiter\": \"\\t\",\n            \"compress\": \"gzip\"\n          }\n        }\n	}\n    ],\n    \"setting\": {\n      \"speed\": {\n        \"channel\": \"2\"\n      }\n    }\n  }\n}', '', '', '2020-03-12 20:22:50', '');
INSERT INTO `job_info` VALUES (4, 1, '0 0 */1 * * ?', 'mysql_hive', '2020-01-10 23:29:49', '2020-03-12 20:00:56', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-01-10 23:29:49', '', 0, 0, 0, '{\n  \"job\": {\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"mysqlreader\",\n          \"parameter\": {\n            \"column\": [\n              \"app_code\",\n              \"app_name\",\n              \"app_type_industry_name\",\n              \"app_type_industry_code\",\n              \"app_type_level2_name\",\n              \"app_type_level2_code\",\n              \"model_type\",\n              \"create_time\"\n            ],\n            \"connection\": [\n              {\n                \"jdbcUrl\": [\n                  \"jdbc:mysql://x.x.x.x:3306/test?autoReconnect=true&useSSL=false&characterEncoding=UTF-8\"\n                ],\n                \"table\": [\n                  \"hive_mysql\"\n                ]\n              }\n            ],\n            \"password\": \"pwd\",\n            \"username\": \"ds\"\n          }\n        },\n        \"writer\": {\n          \"name\": \"hdfswriter\",\n          \"parameter\": {\n			\"fileType\": \"text\",\n            \"fileName\": \"mysql_hive\",\n            \"path\": \"/user/hive/warehouse/tmp.db/tmp_mysql_hive\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"name\": \"app_code\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_name\",\n                \"type\": \"VARCHAR\"\n              },\n			   {\n                \"name\": \"app_type_industry_name\",\n                \"type\": \"VARCHAR\"\n              },\n			   {\n                \"name\": \"app_type_industry_code\",\n                \"type\": \"VARCHAR\"\n              },\n			   {\n                \"name\": \"app_type_level2_name\",\n                \"type\": \"VARCHAR\"\n              },\n			   {\n                \"name\": \"app_type_level2_code\",\n                \"type\": \"VARCHAR\"\n              },\n			   {\n                \"name\": \"model_type\",\n                \"type\": \"VARCHAR\"\n              },\n			   {\n                \"name\": \"create_time\",\n                \"type\": \"VARCHAR\"\n              }\n            ],\n			\"writeMode\": \"append\",\n            \"fieldDelimiter\": \"\\t\",\n            \"compress\": \"gzip\"\n          }\n        }\n		}\n    ],\n    \"setting\": {\n      \"speed\": {\n        \"channel\": \"2\"\n      }\n    }\n  }\n}', '', '', '2020-03-12 20:01:01', '');
INSERT INTO `job_info` VALUES (5, 1, '0 0 */1 * * ?	', 'hive_mysql', '2020-01-10 23:52:03', '2020-03-12 17:11:25', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-01-10 23:52:03', '', 0, 0, 0, '{\n  \"job\": {\n    \"setting\": {\n      \"speed\": {\n        \"channel\": 3\n      }\n    },\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"hdfsreader\",\n          \"parameter\": {\n            \"path\": \"/user/hive/warehouse/dict.db/dict_industry_app\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"index\": 0,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 1,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 2,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 3,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 4,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 5,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 6,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 7,\n                \"type\": \"string\"\n              }\n            ],\n            \"fileType\": \"text\",\n            \"encoding\": \"UTF-8\",\n            \"fieldDelimiter\": \"\\t\"\n          }\n        },\n        \"writer\": {\n          \"name\": \"mysqlwriter\",\n          \"parameter\": {\n            \"writeMode\": \"insert\",\n            \"username\": \"ds\",\n            \"password\": \"pwd\",\n            \"column\": [\n              \"app_code\",\n              \"app_name\",\n              \"app_type_industry_name\",\n              \"app_type_industry_code\",\n              \"app_type_level2_name\",\n              \"app_type_level2_code\",\n              \"model_type\",\n              \"create_time\"\n            ],\n            \"connection\": [\n              {\n                \"jdbcUrl\": \"jdbc:mysql://x.x.x.x:3306/test?autoReconnect=true&useSSL=false&characterEncoding=UTF-8\",\n                \"table\": [\n                  \"hive_mysql\"\n                ]\n              }\n            ]\n          }\n        }\n      }\n    ]\n  }\n}', '', '', '2020-03-12 16:08:31', '');
INSERT INTO `job_info` VALUES (10, 1, '0 0 */1 * * ?', 'pthive_mysql', '2020-03-12 16:24:13', '2020-03-12 16:31:43', 'water', '', 'LAST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 16:24:13', '', 0, 0, 0, '{\n  \"job\": {\n    \"setting\": {\n      \"speed\": {\n        \"channel\": 3\n      }\n    },\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"hdfsreader\",\n          \"parameter\": {\n            \"path\": \"/user/hive/warehouse/dps.db/dps_txt_err/the_date=82679010-08-28/*\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"index\": 0,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 1,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 2,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 3,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 4,\n                \"type\": \"string\"\n              }\n            ],\n            \"fileType\": \"orc\",\n            \"encoding\": \"UTF-8\",\n            \"fieldDelimiter\": \"\\t\"\n          }\n        },\n        \"writer\": {\n          \"name\": \"mysqlwriter\",\n          \"parameter\": {\n            \"writeMode\": \"insert\",\n            \"username\": \"ds\",\n            \"password\": \"pwd\",\n            \"column\": [\n              \"app_name\",\n              \"phone_id\",\n              \"event_time\",\n              \"msg\",\n              \"main_call_no\"\n            ],\n            \"connection\": [\n              {\n                \"jdbcUrl\": \"jdbc:mysql://x.x.x.x:3306/test?autoReconnect=true&useSSL=false&characterEncoding=UTF-8\",\n                \"table\": [\n                  \"pthive_mysql\"\n                ]\n              }\n            ]\n          }\n        }\n      }\n    ]\n  }\n}', '', '', '2020-03-12 16:31:46', '');
INSERT INTO `job_info` VALUES (11, 1, '0 0 */1 * * ?', 'hive_sftp', '2020-03-12 16:48:42', '2020-03-12 17:11:50', 'water', '', 'LAST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 16:48:42', '', 0, 0, 0, '{\n  \"job\": {\n    \"setting\": {\n      \"speed\": {\n        \"channel\": 3\n      }\n    },\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"hdfsreader\",\n          \"parameter\": {\n            \"path\": \"/user/hive/warehouse/dict.db/dict_industry_app\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"index\": 0,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 1,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 2,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 3,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 4,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 5,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 6,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 7,\n                \"type\": \"string\"\n              }\n            ],\n            \"fileType\": \"text\",\n            \"encoding\": \"UTF-8\",\n            \"fieldDelimiter\": \"\\t\"\n          }\n        },\n        \"writer\": {\n          \"name\": \"ftpwriter\",\n          \"parameter\": {\n            \"protocol\": \"sftp\",\n            \"host\": \"x.x.x.x\",\n            \"port\": 22,\n            \"username\": \"sftp_user_a\",\n            \"password\": \"pwd\",\n            \"timeout\": \"60000\",\n            \"connectPattern\": \"PASV\",\n            \"path\": \"/data/yuying\",\n            \"fileName\": \"test_hive_to_sftp\",\n            \"writeMode\": \"truncate\",\n            \"fieldDelimiter\": \"\\t\",\n            \"encoding\": \"UTF-8\",\n            \"nullFormat\": \"null\",\n            \"dateFormat\": \"yyyy-MM-dd\",\n            \"fileFormat\": \"csv\",\n            \"header\": []\n          }\n        }\n      }\n    ]\n  }\n}', '', '', '2020-03-12 16:52:07', '');
INSERT INTO `job_info` VALUES (12, 1, '0 0 */1 * * ?', 'pthive_sftp', '2020-03-12 16:55:55', '2020-03-12 16:55:55', 'water', '', 'LAST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 16:55:55', '', 0, 0, 0, '{\n  \"job\": {\n    \"setting\": {\n      \"speed\": {\n        \"channel\": 3\n      }\n    },\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"hdfsreader\",\n          \"parameter\": {\n            \"path\": \"/user/hive/warehouse/dps.db/dps_txt_err/the_date=82679010-08-28/*\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"index\": 0,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 1,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 2,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 3,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 4,\n                \"type\": \"string\"\n              }\n            ],\n            \"fileType\": \"orc\",\n            \"encoding\": \"UTF-8\",\n            \"fieldDelimiter\": \"\\t\"\n          }\n        },\n        \"writer\": {\n                    \"name\": \"ftpwriter\",\n                    \"parameter\": {\n                        \"protocol\": \"sftp\",\n                        \"host\": \"x.x.x.x\",\n                        \"port\": 22,\n                        \"username\": \"sftp_user_a\",\n                        \"password\": \"pwd\",\n                        \"timeout\": \"60000\",\n                        \"connectPattern\": \"PASV\",\n                        \"path\": \"/data/yuying\",\n                        \"fileName\": \"test_hive_to_sftp\",\n                        \"writeMode\": \"truncate\",\n                        \"fieldDelimiter\": \"\\t\",\n                        \"encoding\": \"UTF-8\",\n                        \"nullFormat\": \"null\",\n                        \"dateFormat\": \"yyyy-MM-dd\",\n                        \"fileFormat\": \"csv\",\n                        \"header\": []\n                    }\n        }\n      }\n    ]\n  }\n}', '', '', '2020-03-12 16:56:00', '');
INSERT INTO `job_info` VALUES (13, 1, '0 0 */1 * * ?', 'hive_file', '2020-03-12 17:01:16', '2020-03-12 17:12:01', 'water', '', 'LAST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 17:01:16', '', 0, 0, 0, '{\n  \"job\": {\n    \"setting\": {\n      \"speed\": {\n        \"channel\": 3\n      }\n    },\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"hdfsreader\",\n          \"parameter\": {\n            \"path\": \"/user/hive/warehouse/dict.db/dict_industry_app\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"index\": 0,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 1,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 2,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 3,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 4,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 5,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 6,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 7,\n                \"type\": \"string\"\n              }\n            ],\n            \"fileType\": \"text\",\n            \"encoding\": \"UTF-8\",\n            \"fieldDelimiter\": \"\\t\"\n          }\n        },\n        \"writer\": {\n          \"name\": \"txtfilewriter\",\n          \"parameter\": {\n            \"path\": \"/data/ds/third_party/hicore\",\n            \"fileName\": \"test_hive_file\",\n            \"writeMode\": \"truncate\",\n            \"dateFormat\": \"yyyy-MM-dd\"\n          }\n        }\n      }\n    ]\n  }\n}', '', '', '2020-03-12 17:03:48', '');
INSERT INTO `job_info` VALUES (14, 1, '0 0 */1 * * ?', 'pthive_file', '2020-03-12 17:02:56', '2020-03-12 17:04:00', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 17:02:56', '', 0, 0, 0, '{\n  \"job\": {\n    \"setting\": {\n      \"speed\": {\n        \"channel\": 3\n      }\n    },\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"hdfsreader\",\n          \"parameter\": {\n            \"path\": \"/user/hive/warehouse/dps.db/dps_txt_err/the_date=82679010-08-28/*\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"index\": 0,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 1,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 2,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 3,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 4,\n                \"type\": \"string\"\n              }\n            ],\n            \"fileType\": \"orc\",\n            \"encoding\": \"UTF-8\",\n            \"fieldDelimiter\": \"\\t\"\n          }\n        },\n        \"writer\": {\n          \"name\": \"txtfilewriter\",\n          \"parameter\": {\n            \"path\": \"/data/ds/third_party/hicore\",\n            \"fileName\": \"test_pthive_file\",\n            \"writeMode\": \"truncate\",\n            \"dateFormat\": \"yyyy-MM-dd\"\n          }\n        }\n      }\n    ]\n  }\n}', '', '', '2020-03-12 17:04:24', '');
INSERT INTO `job_info` VALUES (15, 1, '0 0 */1 * * ?', 'hive_hive', '2020-03-12 17:15:27', '2020-03-12 17:25:11', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 17:15:27', '', 0, 0, 0, '{\n  \"job\": {\n    \"setting\": {\n      \"speed\": {\n        \"channel\": 3\n      }\n    },\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"hdfsreader\",\n          \"parameter\": {\n            \"path\": \"/user/hive/warehouse/dict.db/dict_industry_app\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"index\": 0,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 1,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 2,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 3,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 4,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 5,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 6,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 7,\n                \"type\": \"string\"\n              }\n            ],\n            \"fileType\": \"text\",\n            \"encoding\": \"UTF-8\",\n            \"fieldDelimiter\": \"\\t\"\n          }\n        },\n        \"writer\": {\n                    \"name\": \"hdfswriter\",\n                    \"parameter\": {\n					    \"fileType\": \"text\",\n					    \"fileName\": \"hive_hive\",\n                        \"path\": \"/user/hive/warehouse/tmp.db/tmp_test_hive_to_hive\",\n						\"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n						\"hadoopConfig\": {\n						  \"dfs.data.transfer.protection\": \"integrity\"\n						},\n						\"haveKerberos\": true,\n						\"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n						\"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n                        \"column\": [\n                            {\n                                \"name\": \"app_code\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"app_name\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"app_type_industry_name\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"app_type_industry_code\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"app_type_level2_name\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"app_type_level2_code\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"model_type\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"create_time\",\n                                \"type\": \"string\"\n                            }\n                        ],\n						\n                        \"writeMode\": \"append\",\n                        \"fieldDelimiter\": \"\\t\",\n                        \"compress\":\"gzip\"\n                    }\n                }\n      }\n    ]\n  }\n}', '', '', '2020-03-12 17:25:14', '');
INSERT INTO `job_info` VALUES (16, 1, '0 0 */1 * * ?', 'hive_pthive', '2020-03-12 17:37:47', '2020-03-12 17:37:47', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 17:37:47', '', 0, 0, 0, '{\n  \"job\": {\n    \"setting\": {\n      \"speed\": {\n        \"channel\": 3\n      }\n    },\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"hdfsreader\",\n          \"parameter\": {\n            \"path\": \"/user/hive/warehouse/dict.db/dict_industry_app\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"index\": 0,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 1,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 2,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 3,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 4,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 5,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 6,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 7,\n                \"type\": \"string\"\n              }\n            ],\n            \"fileType\": \"text\",\n            \"encoding\": \"UTF-8\",\n            \"fieldDelimiter\": \"\\t\"\n          }\n        },\n        \"writer\": {\n                    \"name\": \"hdfswriter\",\n                    \"parameter\": {\n					    \"fileType\": \"text\",\n					    \"fileName\": \"hive_hive\",\n                        \"path\": \"/user/hive/warehouse/tmp.db/tmp_test_hive_to_pthive/pt=20200312\",\n						\"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n						\"hadoopConfig\": {\n						  \"dfs.data.transfer.protection\": \"integrity\"\n						},\n						\"haveKerberos\": true,\n						\"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n						\"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n                        \"column\": [\n                            {\n                                \"name\": \"app_code\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"app_name\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"app_type_industry_name\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"app_type_industry_code\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"app_type_level2_name\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"app_type_level2_code\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"model_type\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"create_time\",\n                                \"type\": \"string\"\n                            }\n                        ],\n						\n                        \"writeMode\": \"append\",\n                        \"fieldDelimiter\": \"\\t\",\n                        \"compress\":\"gzip\"\n                    }\n                }\n      }\n    ]\n  }\n}', '', '', '2020-03-12 18:05:26', '');
INSERT INTO `job_info` VALUES (17, 1, '0 0 */1 * * ?', 'pthive_pthive', '2020-03-12 19:22:30', '2020-03-12 19:23:12', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 19:22:30', '', 0, 0, 0, '{\n  \"job\": {\n    \"setting\": {\n      \"speed\": {\n        \"channel\": 3\n      }\n    },\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"hdfsreader\",\n          \"parameter\": {\n            \"path\": \"/user/hive/warehouse/dps.db/dps_txt_err/the_date=82679010-08-28/*\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"index\": 0,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 1,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 2,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 3,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 4,\n                \"type\": \"string\"\n              }\n            ],\n            \"fileType\": \"orc\",\n            \"encoding\": \"UTF-8\",\n            \"fieldDelimiter\": \"\\t\"\n          }\n        },\n        \"writer\": {\n                    \"name\": \"hdfswriter\",\n                    \"parameter\": {\n					    \"fileType\": \"orc\",\n					    \"fileName\": \"pthive_pthive\",\n                        \"path\": \"/user/hive/warehouse/tmp.db/tmp_test_pthive_to_pthive/the_date=20200312/file_no=20200312\",\n						\"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n						\"hadoopConfig\": {\n						  \"dfs.data.transfer.protection\": \"integrity\"\n						},\n						\"haveKerberos\": true,\n						\"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n						\"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n                        \"column\": [\n                            {\n                                \"name\": \"app_name\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"phone_id\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"event_time\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"msg\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"main_call_no\",\n                                \"type\": \"string\"\n                            }\n                        ],\n						\n                        \"writeMode\": \"append\",\n                        \"fieldDelimiter\": \"\\t\",\n                        \"compress\":\"SNAPPY\"\n                    }\n                }\n      }\n    ]\n  }\n}', '', '', '2020-03-12 19:23:19', '');
INSERT INTO `job_info` VALUES (18, 1, '0 0 */1 * * ?', 'pthive_hive', '2020-03-12 19:34:49', '2020-03-12 19:34:49', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 19:34:49', '', 0, 0, 0, '{\n  \"job\": {\n    \"setting\": {\n      \"speed\": {\n        \"channel\": 3\n      }\n    },\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"hdfsreader\",\n          \"parameter\": {\n            \"path\": \"/user/hive/warehouse/dps.db/dps_txt_err/the_date=82679010-08-28/*\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"index\": 0,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 1,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 2,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 3,\n                \"type\": \"string\"\n              },\n              {\n                \"index\": 4,\n                \"type\": \"string\"\n              }\n            ],\n            \"fileType\": \"orc\",\n            \"encoding\": \"UTF-8\",\n            \"fieldDelimiter\": \"\\t\"\n          }\n        },\n        \"writer\": {\n                    \"name\": \"hdfswriter\",\n                    \"parameter\": {\n					    \"fileType\": \"orc\",\n					    \"fileName\": \"pthive_pthive\",\n                        \"path\": \"/user/hive/warehouse/tmp.db/tmp_test_pthive_to_hive\",\n						\"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n						\"hadoopConfig\": {\n						  \"dfs.data.transfer.protection\": \"integrity\"\n						},\n						\"haveKerberos\": true,\n						\"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n						\"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n                        \"column\": [\n                            {\n                                \"name\": \"app_name\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"phone_id\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"event_time\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"msg\",\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"name\": \"main_call_no\",\n                                \"type\": \"string\"\n                            }\n                        ],\n						\n                        \"writeMode\": \"append\",\n                        \"fieldDelimiter\": \"\\t\",\n                        \"compress\":\"SNAPPY\"\n                    }\n                }\n      }\n    ]\n  }\n}', '', '', '2020-03-12 19:35:02', '');
INSERT INTO `job_info` VALUES (19, 1, '0 0 */1 * * ?', 'mysql_pthive', '2020-03-12 20:08:10', '2020-03-12 20:08:10', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 20:08:10', '', 0, 0, 0, '{\n  \"job\": {\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"mysqlreader\",\n          \"parameter\": {\n            \"column\": [\n              \"app_code\",\n              \"app_name\",\n              \"app_type_industry_name\",\n              \"app_type_industry_code\",\n              \"app_type_level2_name\",\n              \"app_type_level2_code\",\n              \"model_type\",\n              \"create_time\"\n            ],\n            \"connection\": [\n              {\n                \"jdbcUrl\": [\n                  \"jdbc:mysql://x.x.x.x:3306/test?autoReconnect=true&useSSL=false&characterEncoding=UTF-8\"\n                ],\n                \"table\": [\n                  \"hive_mysql\"\n                ]\n              }\n            ],\n            \"password\": \"pwd\",\n            \"username\": \"ds\"\n          }\n        },\n        \"writer\": {\n          \"name\": \"hdfswriter\",\n          \"parameter\": {\n			\"fileType\": \"text\",\n            \"fileName\": \"mysql_hive\",\n            \"path\": \"/user/hive/warehouse/tmp.db/tmp_test_mysql_pthive/pt=20200312\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"name\": \"app_code\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_name\",\n                \"type\": \"VARCHAR\"\n              },\n			   {\n                \"name\": \"app_type_industry_name\",\n                \"type\": \"VARCHAR\"\n              },\n			   {\n                \"name\": \"app_type_industry_code\",\n                \"type\": \"VARCHAR\"\n              },\n			   {\n                \"name\": \"app_type_level2_name\",\n                \"type\": \"VARCHAR\"\n              },\n			   {\n                \"name\": \"app_type_level2_code\",\n                \"type\": \"VARCHAR\"\n              },\n			   {\n                \"name\": \"model_type\",\n                \"type\": \"VARCHAR\"\n              },\n			   {\n                \"name\": \"create_time\",\n                \"type\": \"VARCHAR\"\n              }\n            ],\n			\"writeMode\": \"append\",\n            \"fieldDelimiter\": \"\\t\",\n            \"compress\": \"gzip\"\n          }\n        }\n		}\n    ],\n    \"setting\": {\n      \"speed\": {\n        \"channel\": \"2\"\n      }\n    }\n  }\n}', '', '', '2020-03-12 20:08:19', '');
INSERT INTO `job_info` VALUES (20, 1, '0 0 */1 * * ?', 'mysql_file', '2020-03-12 20:10:41', '2020-03-12 20:10:41', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 20:10:41', '', 0, 0, 0, '{\n  \"job\": {\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"mysqlreader\",\n          \"parameter\": {\n            \"column\": [\n              \"app_code\",\n              \"app_name\",\n              \"app_type_industry_name\",\n              \"app_type_industry_code\",\n              \"app_type_level2_name\",\n              \"app_type_level2_code\",\n              \"model_type\",\n              \"create_time\"\n            ],\n            \"connection\": [\n              {\n                \"jdbcUrl\": [\n                  \"jdbc:mysql://x.x.x.x:3306/test?autoReconnect=true&useSSL=false&characterEncoding=UTF-8\"\n                ],\n                \"table\": [\n                  \"hive_mysql\"\n                ]\n              }\n            ],\n            \"password\": \"pwd\",\n            \"username\": \"ds\"\n          }\n        },\n        \"writer\": {\n          \"name\": \"txtfilewriter\",\n          \"parameter\": {\n            \"path\": \"/data/ds/third_party/hicore\",\n            \"fileName\": \"test_mysql_file\",\n            \"writeMode\": \"truncate\",\n            \"dateFormat\": \"yyyy-MM-dd\"\n          }\n        }\n	}\n    ],\n    \"setting\": {\n      \"speed\": {\n        \"channel\": \"2\"\n      }\n    }\n  }\n}', '', '', '2020-03-12 20:10:48', '');
INSERT INTO `job_info` VALUES (21, 1, '0 0 */1 * * ?', 'mysql_sftp', '2020-03-12 20:12:51', '2020-03-12 20:12:51', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 20:12:51', '', 0, 0, 0, '{\n  \"job\": {\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"mysqlreader\",\n          \"parameter\": {\n            \"column\": [\n              \"app_code\",\n              \"app_name\",\n              \"app_type_industry_name\",\n              \"app_type_industry_code\",\n              \"app_type_level2_name\",\n              \"app_type_level2_code\",\n              \"model_type\",\n              \"create_time\"\n            ],\n            \"connection\": [\n              {\n                \"jdbcUrl\": [\n                  \"jdbc:mysql://x.x.x.x:3306/test?autoReconnect=true&useSSL=false&characterEncoding=UTF-8\"\n                ],\n                \"table\": [\n                  \"hive_mysql\"\n                ]\n              }\n            ],\n            \"password\": \"pwd\",\n            \"username\": \"ds\"\n          }\n        },\n        \"writer\": {\n          \"name\": \"ftpwriter\",\n          \"parameter\": {\n            \"protocol\": \"sftp\",\n            \"host\": \"x.x.x.x\",\n            \"port\": 22,\n            \"username\": \"sftp_user_a\",\n            \"password\": \"pwd\",\n            \"timeout\": \"60000\",\n            \"connectPattern\": \"PASV\",\n            \"path\": \"/data/yuying\",\n            \"fileName\": \"test_mysql_to_sftp\",\n            \"writeMode\": \"truncate\",\n            \"fieldDelimiter\": \"\\t\",\n            \"encoding\": \"UTF-8\",\n            \"nullFormat\": \"null\",\n            \"dateFormat\": \"yyyy-MM-dd\",\n            \"fileFormat\": \"csv\",\n            \"header\": []\n          }\n        }\n	}\n    ],\n    \"setting\": {\n      \"speed\": {\n        \"channel\": \"2\"\n      }\n    }\n  }\n}', '', '', '2020-03-12 20:12:56', '');
INSERT INTO `job_info` VALUES (22, 1, '0 0 */1 * * ?', 'mysql_mysql', '2020-03-12 20:14:52', '2020-03-12 20:14:52', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 20:14:52', '', 0, 0, 0, '{\n  \"job\": {\n    \"content\": [\n      {\n        \"reader\": {\n          \"name\": \"mysqlreader\",\n          \"parameter\": {\n            \"column\": [\n              \"app_code\",\n              \"app_name\",\n              \"app_type_industry_name\",\n              \"app_type_industry_code\",\n              \"app_type_level2_name\",\n              \"app_type_level2_code\",\n              \"model_type\",\n              \"create_time\"\n            ],\n            \"connection\": [\n              {\n                \"jdbcUrl\": [\n                  \"jdbc:mysql://x.x.x.x:3306/test?autoReconnect=true&useSSL=false&characterEncoding=UTF-8\"\n                ],\n                \"table\": [\n                  \"hive_mysql\"\n                ]\n              }\n            ],\n            \"password\": \"pwd\",\n            \"username\": \"ds\"\n          }\n        },\n        \"writer\": {\n          \"name\": \"mysqlwriter\",\n          \"parameter\": {\n            \"writeMode\": \"insert\",\n            \"username\": \"ds\",\n            \"password\": \"pwd\",\n            \"column\": [\n              \"app_code\",\n              \"app_name\",\n              \"app_type_industry_name\",\n              \"app_type_industry_code\",\n              \"app_type_level2_name\",\n              \"app_type_level2_code\",\n              \"model_type\",\n              \"create_time\"\n            ],\n            \"connection\": [\n              {\n                \"jdbcUrl\": \"jdbc:mysql://x.x.x.x:3306/test?autoReconnect=true&useSSL=false&characterEncoding=UTF-8\",\n                \"table\": [\n                  \"mysql_mysql\"\n                ]\n              }\n            ]\n          }\n        }\n	}\n    ],\n    \"setting\": {\n      \"speed\": {\n        \"channel\": \"2\"\n      }\n    }\n  }\n}', '', '', '2020-03-12 20:15:24', '');
INSERT INTO `job_info` VALUES (24, 1, '0 0 */1 * * ?', 'file_mysql', '2020-03-12 20:27:07', '2020-03-12 20:27:07', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 20:27:07', '', 0, 0, 0, '{\n  \"job\": {\n    \"content\": [\n      {\n        \"reader\": {\n                    \"name\": \"txtfilereader\",\n                    \"parameter\": {\n                        \"path\": [\"/data/ds/third_party/hicore/test_mysql_file__b46d5bab_4fc1_476f_85f0_7975d422c519\"],\n                        \"encoding\": \"UTF-8\",\n                        \"column\": [\n                            {\n                                \"index\": 0,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 1,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 2,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 3,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 4,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 5,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 6,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 7,\n                                \"type\": \"string\"\n                            }\n                        ],\n                        \"fieldDelimiter\": \",\"\n                    }\n        },,\n        \"writer\": {\n          \"name\": \"mysqlwriter\",\n          \"parameter\": {\n            \"writeMode\": \"insert\",\n            \"username\": \"ds\",\n            \"password\": \"pwd\",\n            \"column\": [\n              \"app_code\",\n              \"app_name\",\n              \"app_type_industry_name\",\n              \"app_type_industry_code\",\n              \"app_type_level2_name\",\n              \"app_type_level2_code\",\n              \"model_type\",\n              \"create_time\"\n            ],\n            \"connection\": [\n              {\n                \"jdbcUrl\": \"jdbc:mysql://x.x.x.x:3306/test?autoReconnect=true&useSSL=false&characterEncoding=UTF-8\",\n                \"table\": [\n                  \"mysql_mysql\"\n                ]\n              }\n            ]\n          }\n        }\n	}\n    ],\n    \"setting\": {\n      \"speed\": {\n        \"channel\": \"2\"\n      }\n    }\n  }\n}', '', '', '2020-03-12 20:29:38', '');
INSERT INTO `job_info` VALUES (25, 1, '0 0 */1 * * ?', 'file_pthive', '2020-03-12 20:32:06', '2020-03-12 20:32:06', 'water', '', 'FIRST', 'executorJobHandler', '', 'DISCARD_LATER', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 20:32:06', '', 0, 0, 0, '{\n  \"job\": {\n    \"content\": [\n      {\n        \"reader\": {\n                    \"name\": \"txtfilereader\",\n                    \"parameter\": {\n                        \"path\": [\"/data/ds/third_party/hicore/test_mysql_file__b46d5bab_4fc1_476f_85f0_7975d422c519\"],\n                        \"encoding\": \"UTF-8\",\n                        \"column\": [\n                            {\n                                \"index\": 0,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 1,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 2,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 3,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 4,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 5,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 6,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 7,\n                                \"type\": \"string\"\n                            }\n                        ],\n                        \"fieldDelimiter\": \",\"\n                    }\n        },,\n        \"writer\": {\n          \"name\": \"hdfswriter\",\n          \"parameter\": {\n            \"fileType\": \"orc\",\n            \"fileName\": \"mysql_hive\",\n            \"path\": \"/user/hive/warehouse/tmp.db/tmp_test_mysql_pthive/pt=20200312\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"name\": \"app_code\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_name\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_industry_name\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_industry_code\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_level2_name\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_level2_code\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"model_type\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"create_time\",\n                \"type\": \"VARCHAR\"\n              }\n            ],\n            \"writeMode\": \"append\",\n            \"fieldDelimiter\": \"\\t\",\n            \"compress\": \"SNAPPY\"\n          }\n        }\n	}\n    ],\n    \"setting\": {\n      \"speed\": {\n        \"channel\": \"2\"\n      }\n    }\n  }\n}', '', '', '2020-03-12 20:32:11', '');
INSERT INTO `job_info` VALUES (26, 1, '0 0 */1 * * ?', 'file_sftp', '2020-03-12 20:34:32', '2020-03-12 20:34:32', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 20:34:32', '', 0, 0, 0, '{\n  \"job\": {\n    \"content\": [\n      {\n        \"reader\": {\n                    \"name\": \"txtfilereader\",\n                    \"parameter\": {\n                        \"path\": [\"/data/ds/third_party/hicore/test_mysql_file__b46d5bab_4fc1_476f_85f0_7975d422c519\"],\n                        \"encoding\": \"UTF-8\",\n                        \"column\": [\n                            {\n                                \"index\": 0,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 1,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 2,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 3,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 4,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 5,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 6,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 7,\n                                \"type\": \"string\"\n                            }\n                        ],\n                        \"fieldDelimiter\": \",\"\n                    }\n        },\n        \"writer\": {\n          \"name\": \"ftpwriter\",\n          \"parameter\": {\n            \"protocol\": \"sftp\",\n            \"host\": \"x.x.x.x\",\n            \"port\": 22,\n            \"username\": \"sftp_user_a\",\n            \"password\": \"pwd\",\n            \"timeout\": \"60000\",\n            \"connectPattern\": \"PASV\",\n            \"path\": \"/data/yuying\",\n            \"fileName\": \"test_file_to_sftp\",\n            \"writeMode\": \"truncate\",\n            \"fieldDelimiter\": \"\\t\",\n            \"encoding\": \"UTF-8\",\n            \"nullFormat\": \"null\",\n            \"dateFormat\": \"yyyy-MM-dd\",\n            \"fileFormat\": \"csv\",\n            \"header\": []\n          }\n        }\n	}\n    ],\n    \"setting\": {\n      \"speed\": {\n        \"channel\": \"2\"\n      }\n    }\n  }\n}', '', '', '2020-03-12 20:34:37', '');
INSERT INTO `job_info` VALUES (27, 1, '0 0 */1 * * ?', 'sftp_sftp', '2020-03-12 20:40:07', '2020-03-12 20:40:07', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 20:40:07', '', 0, 0, 0, '{\n  \"job\": {\n    \"content\": [\n      {\n        \"reader\": {\n                    \"name\": \"ftpreader\",\n                    \"parameter\": {\n                        \"protocol\": \"sftp\",\n                        \"host\": \"x.x.x.x\",\n                        \"port\": 22,\n                        \"username\": \"sftp_user_a\",\n                        \"password\": \"pwd\",\n                        \"path\": [\n                            \"/data/test_file_to_sftp__61eaf05e_6946_4839_8ff4_5ef562ad5346\"\n                        ],\n                        \"column\": [\n                            {\n                                \"index\": 0,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 1,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 2,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 3,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 4,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 5,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 6,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 7,\n                                \"type\": \"string\"\n                            }\n                        ],\n                        \"encoding\": \"UTF-8\",\n                        \"fieldDelimiter\": \",\"\n                    }\n                },\n        \"writer\": {\n          \"name\": \"ftpwriter\",\n          \"parameter\": {\n            \"protocol\": \"sftp\",\n            \"host\": \"x.x.x.x\",\n            \"port\": 22,\n            \"username\": \"sftp_user_a\",\n            \"password\": \"pwd\",\n            \"timeout\": \"60000\",\n            \"connectPattern\": \"PASV\",\n            \"path\": \"/data/yuying\",\n            \"fileName\": \"test_sftp_to_sftp\",\n            \"writeMode\": \"truncate\",\n            \"fieldDelimiter\": \"\\t\",\n            \"encoding\": \"UTF-8\",\n            \"nullFormat\": \"null\",\n            \"dateFormat\": \"yyyy-MM-dd\",\n            \"fileFormat\": \"csv\",\n            \"header\": []\n          }\n        }\n	}\n    ],\n    \"setting\": {\n      \"speed\": {\n        \"channel\": \"2\"\n      }\n    }\n  }\n}', '', '', '2020-03-12 20:40:12', '');
INSERT INTO `job_info` VALUES (28, 1, '0 0 */1 * * ?', 'sftp_file', '2020-03-12 20:42:17', '2020-03-12 22:08:54', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 20:42:17', '', 0, 0, 0, '{\n  \"job\": {\n    \"content\": [\n      {\n        \"reader\": {\n                    \"name\": \"ftpreader\",\n                    \"parameter\": {\n                        \"protocol\": \"sftp\",\n                        \"host\": \"x.x.x.x\",\n                        \"port\": 22,\n                        \"username\": \"sftp_user_a\",\n                        \"password\": \"pwd\",\n                        \"path\": [\n                            \"/data/test_file_sftp\"\n                        ],\n                        \"column\": [\n                            {\n                                \"index\": 0,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 1,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 2,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 3,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 4,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 5,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 6,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 7,\n                                \"type\": \"string\"\n                            }\n                        ],\n                        \"encoding\": \"UTF-8\",\n                        \"fieldDelimiter\": \"\\t\"\n                    }\n                },\n        \"writer\": {\n          \"name\": \"txtfilewriter\",\n          \"parameter\": {\n            \"path\": \"/data/ds/third_party/hicore\",\n            \"fileName\": \"test_sftp_file\",\n            \"writeMode\": \"truncate\",\n            \"dateFormat\": \"yyyy-MM-dd\"\n          }\n        }\n	}\n    ],\n    \"setting\": {\n      \"speed\": {\n        \"channel\": \"2\"\n      }\n    }\n  }\n}', '', '', '2020-03-12 22:09:02', '');
INSERT INTO `job_info` VALUES (29, 1, '0 0 */1 * * ?', 'sftp_mysql', '2020-03-12 21:36:33', '2020-03-12 22:04:22', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 21:36:33', '', 0, 0, 0, '{\n  \"job\": {\n    \"content\": [\n      {\n        \"reader\": {\n                    \"name\": \"ftpreader\",\n                    \"parameter\": {\n                        \"protocol\": \"sftp\",\n                        \"host\": \"x.x.x.x\",\n                        \"port\": 22,\n                        \"username\": \"sftp_user_a\",\n                        \"password\": \"pwd\",\n                        \"path\": [\n                            \"/data/test_file_sftp\"\n                        ],\n                        \"column\": [\n                            {\n                                \"index\": 0,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 1,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 2,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 3,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 4,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 5,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 6,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 7,\n                                \"type\": \"string\"\n                            }\n                        ],\n                        \"encoding\": \"UTF-8\",\n                        \"fieldDelimiter\": \"\\t\"\n                    }\n                },\n        \"writer\": {\n          \"name\": \"mysqlwriter\",\n          \"parameter\": {\n            \"writeMode\": \"insert\",\n            \"username\": \"ds\",\n            \"password\": \"pwd\",\n            \"column\": [\n              \"app_code\",\n              \"app_name\",\n              \"app_type_industry_name\",\n              \"app_type_industry_code\",\n              \"app_type_level2_name\",\n              \"app_type_level2_code\",\n              \"model_type\",\n              \"create_time\"\n            ],\n            \"connection\": [\n              {\n                \"jdbcUrl\": \"jdbc:mysql://x.x.x.x:3306/test?autoReconnect=true&useSSL=false&characterEncoding=UTF-8\",\n                \"table\": [\n                  \"mysql_mysql\"\n                ]\n              }\n            ]\n          }\n        }\n	}\n    ],\n    \"setting\": {\n      \"speed\": {\n        \"channel\": \"2\"\n      }\n    }\n  }\n}', '', '', '2020-03-12 22:04:26', '');
INSERT INTO `job_info` VALUES (30, 1, '0 0 */1 * * ?', 'sftp_hive', '2020-03-12 22:13:20', '2020-03-12 22:13:20', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 22:13:20', '', 0, 0, 0, '{\n  \"job\": {\n    \"content\": [\n      {\n        \"reader\": {\n                    \"name\": \"ftpreader\",\n                    \"parameter\": {\n                        \"protocol\": \"sftp\",\n                        \"host\": \"x.x.x.x\",\n                        \"port\": 22,\n                        \"username\": \"sftp_user_a\",\n                        \"password\": \"pwd\",\n                        \"path\": [\n                            \"/data/test_file_sftp\"\n                        ],\n                        \"column\": [\n                            {\n                                \"index\": 0,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 1,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 2,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 3,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 4,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 5,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 6,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 7,\n                                \"type\": \"string\"\n                            }\n                        ],\n                        \"encoding\": \"UTF-8\",\n                        \"fieldDelimiter\": \"\\t\"\n                    }\n                },\n        \"writer\": {\n          \"name\": \"hdfswriter\",\n          \"parameter\": {\n            \"fileType\": \"text\",\n            \"fileName\": \"mysql_hive\",\n            \"path\": \"/user/hive/warehouse/tmp.db/tmp_mysql_hive\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"name\": \"app_code\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_name\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_industry_name\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_industry_code\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_level2_name\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_level2_code\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"model_type\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"create_time\",\n                \"type\": \"VARCHAR\"\n              }\n            ],\n            \"writeMode\": \"append\",\n            \"fieldDelimiter\": \"\\t\",\n            \"compress\": \"gzip\"\n          }\n        }\n	}\n    ],\n    \"setting\": {\n      \"speed\": {\n        \"channel\": \"2\"\n      }\n    }\n  }\n}', '', '', '2020-03-12 22:13:28', '');
INSERT INTO `job_info` VALUES (31, 1, '0 0 */1 * * ?', 'sftp_pthive', '2020-03-12 22:15:57', '2020-03-12 22:18:21', 'water', '', 'FIRST', 'executorJobHandler', '', 'SERIAL_EXECUTION', 0, 0, 'BEAN', NULL, NULL, '2020-03-12 22:15:57', '', 0, 0, 0, '{\n  \"job\": {\n    \"content\": [\n      {\n        \"reader\": {\n                    \"name\": \"ftpreader\",\n                    \"parameter\": {\n                        \"protocol\": \"sftp\",\n                        \"host\": \"x.x.x.x\",\n                        \"port\": 22,\n                        \"username\": \"sftp_user_a\",\n                        \"password\": \"pwd\",\n                        \"path\": [\n                            \"/data/test_file_sftp\"\n                        ],\n                        \"column\": [\n                            {\n                                \"index\": 0,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 1,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 2,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 3,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 4,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 5,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 6,\n                                \"type\": \"string\"\n                            },\n                            {\n                                \"index\": 7,\n                                \"type\": \"string\"\n                            }\n                        ],\n                        \"encoding\": \"UTF-8\",\n                        \"fieldDelimiter\": \"\\t\"\n                    }\n                },\n        \"writer\": {\n          \"name\": \"hdfswriter\",\n          \"parameter\": {\n            \"fileType\": \"orc\",\n            \"fileName\": \"mysql_hive\",\n            \"path\": \"/user/hive/warehouse/tmp.db/tmp_test_mysql_pthive/pt=20200312\",\n            \"defaultFS\": \"hdfs://dz-hadoop-nn1:8020\",\n            \"hadoopConfig\": {\n              \"dfs.data.transfer.protection\": \"integrity\"\n            },\n            \"haveKerberos\": true,\n            \"kerberosKeytabFilePath\": \"/home/xxx.keytab\",\n            \"kerberosPrincipal\": \"xxx@EXAMPLE.COM\",\n            \"column\": [\n              {\n                \"name\": \"app_code\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_name\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_industry_name\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_industry_code\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_level2_name\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"app_type_level2_code\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"model_type\",\n                \"type\": \"VARCHAR\"\n              },\n              {\n                \"name\": \"create_time\",\n                \"type\": \"VARCHAR\"\n              }\n            ],\n            \"writeMode\": \"append\",\n            \"fieldDelimiter\": \"\\t\",\n            \"compress\": \"SNAPPY\"\n          }\n        }\n	}\n    ],\n    \"setting\": {\n      \"speed\": {\n        \"channel\": \"2\"\n      }\n    }\n  }\n}', '', '', '2020-03-12 22:18:24', '');

SET FOREIGN_KEY_CHECKS = 1;
